Subject: Re: [OSPF] 答复: ??: WG Last Call for "Signalling ELC using OSPF"

From: "Acee Lindem (acee)" <[email-masked]>
Date: Wed, 23 Nov 2016 15:13:16 +0000

Hi Tiger,

Ok – but I believe we need to be clear that in this context, “egress” refers to any to router that will encounter <ELI, EL> at the top of the stack or after popping the top label and not the final “egress” of the LSP.

Bruno has also proposed that the EL capability be used to determine if a transit LSR supports EL based load balancing and inserting an <ELI, EL> pair within that LSR’s RLD will be of any value. If you read RFC 6790, it would imply that an LSR that is able to pop the <ELI, EL> pair MAY also load balance based on the pair. Personally, I don’t know why  a data plane implementation would recognize the <ELI, EL> pair but not  use them for load balancing when multiple paths exist. Consistent with RFC 6790, can we add this usage as a “MAY”?

Thanks,
Acee

From: Xiaohu Xu <[email-masked]<mailto:[email-masked]>>
Date: Tuesday, November 22, 2016 at 8:35 PM
To: Acee Lindem <[email-masked]<mailto:[email-masked]>>, Bruno Decraene <[email-masked]<mailto:[email-masked]>>
Cc: OSPF WG List <[email-masked]<mailto:[email-masked]>>, "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>, "Carlos Pignataro (cpignata)" <[email-masked]<mailto:[email-masked]>>
Subject: 答复: [OSPF] ??: WG Last Call for "Signalling ELC using OSPF"

Hi Acee,

The ELC is only used to indicate that the advertising router as an egress of a given LSP could pop the EL/ELI pair. As such, the ingress of an LSP doesn’t know whether those transit LSRs along this LSP could perform EL-based load-balancing when inserting EL/ELI.

Best regards,
Xiaohu

发件人: Acee Lindem (acee) [mailto:[email-masked]]
发送时间: 2016年11月22日 1:41
收件人: [email-masked]<mailto:[email-masked]>
抄送: OSPF WG List; [email-masked]<mailto:[email-masked]>; Carlos Pignataro (cpignata); Xuxiaohu
主题: Re: [OSPF] ??: WG Last Call for "Signalling ELC using OSPF"

Hi Bruno,

From: Bruno Decraene <[email-masked]<mailto:[email-masked]>>
Date: Monday, November 21, 2016 at 12:21 PM
To: Acee Lindem <[email-masked]<mailto:[email-masked]>>
Cc: OSPF WG List <[email-masked]<mailto:[email-masked]>>, "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>, "Carlos Pignataro (cpignata)" <[email-masked]<mailto:[email-masked]>>, Xiaohu Xu <[email-masked]<mailto:[email-masked]>>
Subject: RE: [OSPF] ??: WG Last Call for "Signalling ELC using OSPF"

Hi Acee,

From: Acee Lindem (acee) [mailto:[email-masked]]
Sent: Monday, November 21, 2016 6:02 PM
To: DECRAENE Bruno IMT/OLN; Xuxiaohu
Cc: OSPF WG List; [email-masked]<mailto:[email-masked]>; Carlos Pignataro (cpignata)
Subject: Re: [OSPF] ??: WG Last Call for "Signalling ELC using OSPF"

Hi Bruno,

From: Bruno Decraene <[email-masked]<mailto:[email-masked]>>
Date: Monday, November 21, 2016 at 9:43 AM
To: Acee Lindem <[email-masked]<mailto:[email-masked]>>, Xiaohu Xu <[email-masked]<mailto:[email-masked]>>
Cc: OSPF WG List <[email-masked]<mailto:[email-masked]>>, "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>, "Carlos Pignataro (cpignata)" <[email-masked]<mailto:[email-masked]>>
Subject: RE: [OSPF] ??: WG Last Call for "Signalling ELC using OSPF"

Hi Acee,

From: Acee Lindem (acee) [mailto:[email-masked]]
Sent: Saturday, November 19, 2016 12:33 AM
To: DECRAENE Bruno IMT/OLN; Xuxiaohu
Cc: OSPF WG List; [email-masked]<mailto:[email-masked]>; Carlos Pignataro (cpignata)
Subject: Re: [OSPF] ??: WG Last Call for "Signalling ELC using OSPF"

Hi Bruno,

From: OSPF <[email-masked]<mailto:[email-masked]>> on behalf of Bruno Decraene <[email-masked]<mailto:[email-masked]>>
Date: Friday, November 18, 2016 at 11:30 AM
To: Xiaohu Xu <[email-masked]<mailto:[email-masked]>>
Cc: OSPF WG List <[email-masked]<mailto:[email-masked]>>, "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>, "Carlos Pignataro (cpignata)" <[email-masked]<mailto:[email-masked]>>
Subject: Re: [OSPF] ??: WG Last Call for "Signalling ELC using OSPF"

Hi Xiaohu,

Please see inline [Bruno]

From: Xuxiaohu [mailto:[email-masked]]
Sent: Monday, November 14, 2016 1:00 PM
To: DECRAENE Bruno IMT/OLN
Cc: OSPF WG List; Carlos Pignataro (cpignata); [email-masked]<mailto:[email-masked]>
Subject: ??: [OSPF] ??: WG Last Call for "Signalling ELC using OSPF"

Hi Bruno,

Could you please explain why the defination of the RLDC should be specific to the LB behavior of the transit LSR?

[Bruno] The whole purpose of EL and ELC is to improve load balancing of MPLS packets on transit LSR.

According to §6 of your draft, RLDC is also used to improve load-balancing : “The RLDC is used by ingress LSRs
   to determine whether it's necessary to insert an EL for a given LSP
   tunnel in the case where there has already been at least one EL in
   the label stack. »

What would be the point for the ingress to add an additional EL, within the RLDC of LSR A, if LSR A do not use this EL to improve the load balancing?

cf my example below where a LSR can read 5 labels, yet do not use those 5 labels for the load-balancing hence would not benefit from adding an EL within those 5 labels.

BTW, it would be useful for the discussion if you could reply to the content of my email sent: Monday, November 14, 2016 (also included below). As this was already the second time I send this example on the OSPF mailing list.

If I understand correctly, it seems that the text proposed by you conflict with Acee's take (see blow):

"   1. The standards track IGP drafts should have a precise definition of RLD and so not require a normative reference to the MPLS entropy draft (which is informational). The IGP drafts need not precisely specify how the information is used - this can be specified via a reference to the MPLS draft.
   2. The MPLS draft should precisely specify the initial use case of entropy label insertion at the ingress of the LSP. It should not limit the applicability of RLDC to this use case. "

[Bruno] I’m not seeing any conflict. I agree with both points. In this thread, I’m working on 1, i.e. having a clear definition of RLD.  But I would also like that this RLD advertisement be effective in improving the load-balancing of MPLS packets.

I think Readable Label Depth (RLD) should be independent of EL Capability (ELC). It allows advertisement of the the maximum number of labels an OSPF router will examine in a received MPLS encapsulated packet.
 If an OSPF Router supports ELC, it would imply that it support the EL Capability within RLD labels.
[Bruno] Would work for me, assuming that this is stated in the document, and :s/support the EL Capability within RLD labels/for load-balancing purpose, use the EL within RLD labels.
I would propose the following text: “RLDC is the maximum number of labels, from the top of the stack, where the MPLS transit LSR searches for the ELI,EL pair and load-balance based on the EL if present.”

I would completely decouple the two capabilities. Here is the text I would recommend.

The Readable Label Depth (RLD) is the maximum number of labels, starting with top or first label in the stack, that an LSR can examine in a received MPLS packet.  The supported RLD can be important when searching for an entropy label for purpose of load-balancing as the <ELI, EL> pair must be included in the first RLD labels in the stack.

[Bruno] What would you use this RLD information for?
Current OSPF draft proposes to use it to make a decision on whether/where adding an additional ELI, EL pairs in the stack of labels. But if we don’t know whether that additional EL, within the RLD, will be used for load-balancing purpose, the ingress can’t know whether adding this ELI, EL is useful or not. Since we are in a context where the number of labels that can be pushed is limited, we may be wasting 2 label push for zero benefit.

As the name would imply, Entropy Label Capability (ELC) would be used to determine if the LSR supports load-balancing. The RLD capability, also as as the name would imply, would be used solely to determine the number of labels an LSR will read.

Am I the only one who thinks this is obvious?

think ELC should be defined in RFC 6790 and the SPRING Entropy label draft as opposed to the IGP advertisement drafts.
[Bruno] I tend to agree that the definition of RLD, or the load-balancing behavior of a transit LSR supporting EL, would be better specified by the MPLS WG. Then the value advertised by control plane protocols/signaling.
https://tools.ietf.org/html/rfc7325#section-2.4.5 talks about this, but the document is informational, and the text is a bit too large/ open to have the LSR behavior advertised in the IGP using a single integer.
But this option may delay a lot the IGP draft, unless it is splitted in 2 parts (as ELC is ready). Alternatively, I’m ok with your above proposition.

Why can’t we simply use the definition of entropy processing included in RFC 6790 section 4?
[Bruno] Basically, section 4.3 says that the LSR can load-balance based on whatever it wants, and not necessarily based on the EL label. If it does not use the EL label, there is no point in the ingress trying to add additional ELI,EL labels within the RLD of this LSR.

I’d say that a router supporting ELC recognizes the <ELI, EL> label in the first RLD labels and MAY load-balance as described in RFC 6790. An OSPF document should not update the MPLS data plane behavior.

Which is the purpose of advertising the RLD (AFAIK).

It is one usage of RLD – however, the maximum number of labels an LSR can examine must not be inextricably tied to the Entropy Label processing.

Thanks,
Acee

Thanks
--Bruno

Thanks,
Acee

_________________________________________________________________________________________________________________________

Ce message et ses pieces jointes peuvent contenir des informations confidentielles ou privilegiees et ne doivent donc

pas etre diffuses, exploites ou copies sans autorisation. Si vous avez recu ce message par erreur, veuillez le signaler

a l'expediteur et le detruire ainsi que les pieces jointes. Les messages electroniques etant susceptibles d'alteration,

Orange decline toute responsabilite si ce message a ete altere, deforme ou falsifie. Merci.

This message and its attachments may contain confidential or privileged information that may be protected by law;

they should not be distributed, used or copied without authorisation.

If you have received this email in error, please notify the sender and delete this message and its attachments.

As emails may be altered, Orange is not liable for messages that have been modified, changed or falsified.

Thank you.

---

From: Xuxiaohu <[email-masked]>
Date: Thu, 24 Nov 2016 01:56:43 +0000

Hi Acee,

发件人: Acee Lindem (acee) [mailto:[email-masked]]
发送时间: 2016年11月23日 23:13
收件人: Xuxiaohu; [email-masked]
抄送: OSPF WG List; [email-masked]; Carlos Pignataro (cpignata)
主题: Re: 答复: [OSPF] ??: WG Last Call for "Signalling ELC using OSPF"

Hi Tiger,

[Xiaohu] Did you mean the egress of the tunnel that consists of multiple LSPs by the final egress of the LSP? If so, yes. Each explicit hop within the explicit source path is an egress of a given LSP (i.e., node segment).

[Xiaohu] Sure. The ELC term used in this draft is strictly referred to the definition of ELC in RFC6790.

Best regards,
Xiaohu

Thanks,
Acee

Hi Acee,

Best regards,
Xiaohu

Hi Bruno,

Hi Acee,

Hi Bruno,

Hi Acee,

Hi Bruno,

Hi Xiaohu,

Hi Bruno,

Thanks,
Acee

Thanks
--Bruno

Thanks,
Acee

Thank you.